"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.value = exports.unsafeWipe = exports.make = exports.isRedacted = exports.getEquivalence = exports.RedactedTypeId = void 0;
var Equivalence = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("./Equivalence.js"));
var redacted_ = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("./internal/redacted.js"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/**
 * @since 3.3.0
 * @category symbols
 */
const RedactedTypeId = exports.RedactedTypeId = redacted_.RedactedTypeId;
/**
 * @since 3.3.0
 * @category refinements
 */
const isRedacted = exports.isRedacted = redacted_.isRedacted;
/**
 * @since 3.3.0
 * @category constructors
 */
const make = exports.make = redacted_.make;
/**
 * @since 3.3.0
 * @category getters
 */
const value = exports.value = redacted_.value;
/**
 * @since 3.3.0
 * @category unsafe
 */
const unsafeWipe = exports.unsafeWipe = redacted_.unsafeWipe;
/**
 * @category equivalence
 * @since 3.3.0
 */
const getEquivalence = isEquivalent => Equivalence.make((x, y) => x === y || isEquivalent(value(x), value(y)));
exports.getEquivalence = getEquivalence;
//# sourceMappingURL=Redacted.js.map