import * as Equivalence from "./Equivalence.js";
import * as redacted_ from "./internal/redacted.js";
/**
 * @since 3.3.0
 * @category symbols
 */
export const RedactedTypeId = redacted_.RedactedTypeId;
/**
 * @since 3.3.0
 * @category refinements
 */
export const isRedacted = redacted_.isRedacted;
/**
 * @since 3.3.0
 * @category constructors
 */
export const make = redacted_.make;
/**
 * @since 3.3.0
 * @category getters
 */
export const value = redacted_.value;
/**
 * @since 3.3.0
 * @category unsafe
 */
export const unsafeWipe = redacted_.unsafeWipe;
/**
 * @category equivalence
 * @since 3.3.0
 */
export const getEquivalence = isEquivalent => Equivalence.make((x, y) => x === y || isEquivalent(value(x), value(y)));
//# sourceMappingURL=Redacted.js.map